﻿Imports Infragistics.UltraChart.Shared.Styles
Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Core.Layers
Imports Infragistics.UltraChart.Core.Primitives

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        ' DataSource
        Dim dt As New DataTable()
        dt.Columns.Add("Items", GetType(String))
        dt.Columns.Add("Miles Column", GetType(Decimal))
        dt.Columns.Add("Fillups Column", GetType(Decimal))

        dt.Rows.Add("Item 1", 110, 20)
        dt.Rows.Add("Item 2", 115, 30)
        dt.Rows.Add("Item 3", 120, 40)
        dt.Rows.Add("Item 4", 125, 55)


        UltraChart1.ChartType = ChartType.Composite
        UltraChart1.BackColor = Color.Black
        UltraChart1.Data.ZeroAligned = True
        UltraChart1.TitleTop.Text = "Miles to Fillups Analysis"
        UltraChart1.TitleTop.FontColor = Color.Yellow
        UltraChart1.TitleTop.Font = New Font("Arial", 14.0F)
        UltraChart1.TitleTop.HorizontalAlign = StringAlignment.Center


        ' Create the Chart Area
        Dim area As New ChartArea()
        area.BoundsMeasureType = MeasureType.Percentage
        area.Bounds = New Rectangle(25, 10, 74, 90)
        area.Border.Thickness = 0


        Dim xAxis As New AxisItem()
        xAxis.OrientationType = AxisNumber.X_Axis
        xAxis.DataType = AxisDataType.[String]
        xAxis.SetLabelAxisType = SetLabelAxisType.GroupBySeries
        xAxis.LineColor = Color.White
        xAxis.Labels.SeriesLabels.Visible = False
        xAxis.Labels.Visible = False
        xAxis.MajorGridLines.Visible = False

        Dim yAxis As New AxisItem()
        yAxis.OrientationType = AxisNumber.Y_Axis
        yAxis.Extent = 60
        yAxis.TickmarkStyle = AxisTickStyle.Smart
        yAxis.DataType = AxisDataType.Numeric
        yAxis.LineColor = Color.White
        yAxis.Labels.FontColor = Color.White
        yAxis.Labels.ItemFormatString = "<DATA_VALUE:#0.00 ->"
        yAxis.Labels.HorizontalAlign = StringAlignment.Far
        yAxis.RangeType = AxisRangeType.[Custom]
        yAxis.RangeMin = 100
        yAxis.RangeMax = 200

        Dim y2Axis As New AxisItem()
        y2Axis.OrientationType = AxisNumber.Y2_Axis
        y2Axis.Extent = 50
        y2Axis.TickmarkStyle = AxisTickStyle.Smart
        y2Axis.MajorGridLines.Visible = False
        y2Axis.DataType = AxisDataType.Numeric
        y2Axis.LineColor = Color.White
        y2Axis.Labels.FontColor = Color.White
        y2Axis.Labels.ItemFormatString = "<DATA_VALUE:- #0.00>"
        y2Axis.RangeType = AxisRangeType.[Custom]
        y2Axis.RangeMin = 0
        y2Axis.RangeMax = 60


        Dim columnSeries As New NumericSeries()
        columnSeries.DataBind(dt, "Miles Column", "Items")
        columnSeries.PEs.Add(New PaintElement(Color.Gold))
        columnSeries.Label = "Miles [nm]"


        Dim columnSeries2 As New NumericSeries()
        columnSeries2.DataBind(dt, "Fillups Column", "Items")
        columnSeries2.PEs.Add(New PaintElement(Color.Red))
        columnSeries2.Label = "Fillups [fl]"

        Dim ColumnLayer As New ChartLayerAppearance()
        ColumnLayer.ChartType = ChartType.ColumnChart
        ColumnLayer.Series.Add(columnSeries)
        ColumnLayer.ChartArea = area
        ColumnLayer.AxisX = xAxis
        ColumnLayer.AxisY = yAxis
        ColumnLayer.AxisY2 = y2Axis
        ColumnLayer.SwapRowsAndColumns = True

        Dim ColumnLayer2 As New ChartLayerAppearance()
        ColumnLayer2.ChartType = ChartType.ColumnChart
        ColumnLayer2.Series.Add(columnSeries2)
        ColumnLayer2.ChartArea = area
        ColumnLayer2.AxisX = xAxis
        ColumnLayer2.AxisY = y2Axis
        ColumnLayer2.SwapRowsAndColumns = True

        area.Axes.Add(xAxis)
        area.Axes.Add(yAxis)
        area.Axes.Add(y2Axis)
        UltraChart1.CompositeChart.ChartAreas.Add(area)
        UltraChart1.CompositeChart.ChartLayers.Add(ColumnLayer)
        UltraChart1.CompositeChart.ChartLayers.Add(ColumnLayer2)
        UltraChart1.CompositeChart.Series.Add(columnSeries)
        UltraChart1.CompositeChart.Series.Add(columnSeries2)

        Dim AxisYLabel As New BoxAnnotation()
        AxisYLabel.Text = "Miles"
        AxisYLabel.Border.Color = Color.Transparent
        AxisYLabel.FillColor = UltraChart1.BackColor
        AxisYLabel.TextStyle.FontColor = Color.White
        AxisYLabel.Location.Type = LocationType.Percentage
        AxisYLabel.Location.LocationX = area.Bounds.X + 2
        AxisYLabel.Location.LocationY = area.Bounds.Y - 2
        UltraChart1.Annotations.Annotations.Add(AxisYLabel)


        Dim AxisY2Label As New BoxAnnotation()
        AxisY2Label.Text = "Fillups"
        AxisY2Label.Width = -1
        AxisY2Label.TextStyle.HorizontalAlign = StringAlignment.Far
        AxisY2Label.Border.Color = Color.Transparent
        AxisY2Label.FillColor = UltraChart1.BackColor
        AxisY2Label.TextStyle.FontColor = Color.White
        AxisY2Label.Location.Type = LocationType.Percentage
        AxisY2Label.Location.LocationX = (area.Bounds.X + area.Bounds.Width) - 4
        AxisY2Label.Location.LocationY = area.Bounds.Y - 2
        UltraChart1.Annotations.Annotations.Add(AxisY2Label)
        UltraChart1.Legend.DataAssociation = ChartTypeData.SplitData


        ' Add a Legend
        Dim m_ChartLegend As New CompositeLegend()
        ColumnLayer.LegendItem = LegendItemType.Auto
        m_ChartLegend.ChartLayers.Add(ColumnLayer)
        m_ChartLegend.ChartLayers.Add(ColumnLayer2)
        m_ChartLegend.BoundsMeasureType = MeasureType.Percentage
        m_ChartLegend.Bounds = New Rectangle(1, 10, 18, 20)
        area.BoundsMeasureType = MeasureType.Percentage
        area.Bounds = New Rectangle(25, 10, 74, 90)
        m_ChartLegend.PE.ElementType = PaintElementType.Gradient
        m_ChartLegend.PE.FillGradientStyle = GradientStyle.Circular
        m_ChartLegend.PE.Fill = Color.Yellow
        m_ChartLegend.PE.FillStopColor = Color.Orange
        m_ChartLegend.Border.CornerRadius = 10
        m_ChartLegend.Border.Thickness = 0
        m_ChartLegend.LabelStyle.FontSizeBestFit = True
        UltraChart1.CompositeChart.Legends.Add(m_ChartLegend)



        Dim initColor As Color() = New Color() {Color.Red, Color.Gold}
        Me.UltraChart1.ColorModel.CustomPalette = initColor


    End Sub

    Private Sub UltraChart1_FillSceneGraph(sender As System.Object, e As Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs) Handles UltraChart1.FillSceneGraph
        Dim list As New List(Of Primitive)()
        For Each pr As Primitive In e.SceneGraph
            Dim pl As Box = TryCast(pr, Box)
            If pl IsNot Nothing AndAlso pl.Series IsNot Nothing AndAlso pl.Layer.LayerID = "chartLayer2" Then
                pl.rect = New Rectangle(pl.rect.X + (pl.rect.Width / 2) + 1, pl.rect.Y, pl.rect.Width - (pl.rect.Width / 2), pl.rect.Height)
            End If
            If pl IsNot Nothing AndAlso pl.Series IsNot Nothing AndAlso pl.Layer.LayerID = "chartLayer1" Then
                pl.rect = New Rectangle(pl.rect.X, pl.rect.Y, pl.rect.Width - (pl.rect.Width / 2), pl.rect.Height)
            End If

            If pl IsNot Nothing AndAlso pl.Series IsNot Nothing AndAlso pl.Layer.LayerID = "chartLayer1" Then
                Dim txt As New Text()
                txt.PE.Fill = Color.White
                txt.SetTextString(pl.Series.Label)
                txt.bounds.Location = New Point(pl.rect.X + (pl.rect.Width / 2), pl.rect.Y + pl.rect.Height + 10)
                list.Add(txt)
            End If
        Next

        For Each txt As Text In list
            e.SceneGraph.Add(txt)
        Next

    End Sub
End Class
